1.5 RC1 edit host generates undefined method `class_from_string' for Fog:Module error
Status: Closed   

Priority: Normal   

Assignee: Dominic Cleal   

Category: Compute resources   

Target version: 1.5.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.5.0

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

I just did a upgrade path from 1.4.2 to 1.5 RC 1 on a Debian Wheezy and all went well. Minor issue with a plugin but was no big deal.

Then I tried to look at a host and go edit and it generated the following error :

undefined method `class_from_string' for Fog:Module

trace :

NoMethodError

undefined method `class_from_string' for Fog:Module

app/models/compute_resources/foreman/model/vmware.rb:210:in `new_interface'

app/views/compute_resources_vms/form/_vmware.html.erb:13:in `_065ef164aa9163f8a130e7ef5bb9005c'

app/views/hosts/_compute.html.erb:5:in `block in _3e81053728f343221f0e0a0fd07a9774'

app/views/hosts/_compute.html.erb:1:in `_3e81053728f343221f0e0a0fd07a9774'

app/views/hosts/_unattended.html.erb:2:in `_f7a136f70b874dce5b86db3f817c4965'

app/views/hosts/_form.html.erb:92:in `block (2 levels) in _a0e2484de3577d06d43dae28d996d4b7'

app/helpers/layout_helper.rb:248:in `form_for'

app/views/hosts/_form.html.erb:8:in `block in _a0e2484de3577d06d43dae28d996d4b7'

app/models/taxonomy.rb:48:in `block (2 levels) in as_taxonomy'

app/models/concerns/foreman/thread_session.rb:143:in `as_location'

app/models/taxonomy.rb:47:in `block in as_taxonomy'

app/models/concerns/foreman/thread_session.rb:108:in `as_org'

app/models/taxonomy.rb:46:in `as_taxonomy'

app/views/hosts/_form.html.erb:6:in `_a0e2484de3577d06d43dae28d996d4b7'

app/views/hosts/edit.html.erb:9:in `_a625d00f3a4561297d09de55d2256efd'

app/models/concerns/foreman/thread_session.rb:33:in `clear_thread'

lib/middleware/catch_json_parse_errors.rb:9:in `call'

Related issues:

Related to Foreman - Tracker #5474: Upgrade to fog > 1.22 Rejected

Associated revisions

Revision a253106b - 04/28/2014 11:28 AM - Dominic Cleal

fixes #5248 - restrict fog-core to compatible version (fog#2873)

Revision fd04a03e - 04/28/2014 11:51 AM - Dominic Cleal

fixes #5248 - restrict fog-core to compatible version (fog#2873)

(cherry picked from commit a253106b8c0dc46ce49188d968edc745a0bc4a68)

History

#1 - 04/20/2014 09:30 AM - Dominic Cleal

- Subject changed from 1.5 RC1 edit host generates error to 1.5 RC1 edit host generates undefined method `class_from_string' for Fog:Module error

- Category set to Compute resources

- Status changed from New to Ready For Testing

- Assignee set to Dominic Cleal
- Target version set to 1.8.4

- translation missing: en.field_release set to 4

Looks like an incompatibility with fog-core 1.22, I've raised https://github.com/fog/fog/issues/2873 to question what level of compatibility we should

expect.

https://github.com/theforeman/foreman/pull/1395 restricts it.  You can apply this and run "cd ~foreman && bundle update fog-core" to downgrade it.

#2 - 04/20/2014 10:00 AM - Jelle B.

Hi Dom,

Jup that sure made the issue go away , and also resolv an issue creating a new host.

But :

Failed to create a compute SysEng-vCenter (VMWare) instance test9.lab2.lan: failed to create vm: undefined method `new' for

"VirtualVmxnet3":String

I assume it is related.

#3 - 04/20/2014 10:42 AM - Jelle B.

- File 1.5 host new vmware trace added

Here is the full flow trace from the production.log

#4 - 04/23/2014 12:45 PM - Jelle B.

Failed to create a compute SysEng-vCenter (VMWare) instance sipwise.lab2.sys.ecotel.lan: failed to create vm: undefined method `new' for

"VirtualVmxnet3":String

Issue that remains

#5 - 04/24/2014 10:22 AM - Anonymous

- Target version changed from 1.8.4 to 1.8.3

#6 - 04/24/2014 10:22 AM - Anonymous

- Target version changed from 1.8.3 to 1.8.4

#7 - 04/24/2014 10:25 AM - Anonymous

- Target version changed from 1.8.4 to 1.8.3

#8 - 04/25/2014 05:14 PM - Dominic Cleal

I can reproduce this issue and have filed it as #5453 so I can address it separately, but still for 1.5.0.

#9 - 04/28/2014 11:31 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset a253106b8c0dc46ce49188d968edc745a0bc4a68.

#10 - 04/28/2014 02:39 PM - Dominic Cleal

- Related to Tracker #5474: Upgrade to fog > 1.22 added

Files

1.5 host new vmware trace 32.1 KB 04/20/2014 Jelle B.
